PingOne Platform APIs

Step 5: Confirm device user code

 

POST {{authPath}}/{{envID}}/flows/{{flowID}}

To respond to the DAG_USER_CODE_REQUIRED flow state, the user initiates the userCode.verify action. The flow service calls the POST /{{envID}}/flows/{{flowID}} endpoint operation and uses the application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json custom media type in the Content-type HTTP request header to identify the action.

The request body requires the user_code property, which specifies the user’s activation code returned as the user_code value returned by the authorization request. In this workflow, if the userCode.verify action completes successfully, the flow proceeds to the next action. In this case, the flow status value of DAG_CONSENT_REQUIRED requires an acceptance of the device authorization grant consent agreement.

Headers

Content-Type      application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json

Body

raw ( application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json )

{
    "userCode": "{{userCode}}"
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{authPath}}/{{envID}}/flows/{{flowID}}' \
--header 'Content-Type: application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json' \
--data '{
    "userCode": "{{userCode}}"
}'
var options = new RestClientOptions("{{authPath}}/{{envID}}/flows/{{flowID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json");
var body = @"{" + "\n" +
@"    ""userCode"": ""{{userCode}}""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{authPath}}/{{envID}}/flows/{{flowID}}"
  method := "POST"

  payload := strings.NewReader(`{
    "userCode": "{{userCode}}"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /{{envID}}/flows/{{flowID}} HTTP/1.1
Host: {{authPath}}
Content-Type: application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json

{
    "userCode": "{{userCode}}"
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"userCode\": \"{{userCode}}\"\n}");
Request request = new Request.Builder()
  .url("{{authPath}}/{{envID}}/flows/{{flowID}}")
  .method("POST", body)
  .addHeader("Content-Type", "application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{authPath}}/{{envID}}/flows/{{flowID}}",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json"
  },
  "data": JSON.stringify({
    "userCode": "{{userCode}}"
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{authPath}}/{{envID}}/flows/{{flowID}}',
  'headers': {
    'Content-Type': 'application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json'
  },
  body: JSON.stringify({
    "userCode": "{{userCode}}"
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{authPath}}/{{envID}}/flows/{{flowID}}"

payload = json.dumps({
  "userCode": "{{userCode}}"
})
headers = {
  'Content-Type': 'application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{authPath}}/{{envID}}/flows/{{flowID}}');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json'
));
$request->setBody('{\n    "userCode": "{{userCode}}"\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{authPath}}/{{envID}}/flows/{{flowID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json"
request.body = JSON.dump({
  "userCode": "{{userCode}}"
})

response = http.request(request)
puts response.read_body
let parameters = "{\n    \"userCode\": \"{{userCode}}\"\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{authPath}}/{{envID}}/flows/{{flowID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/vnd.pingidentity.deviceAuthGrant.userCode.verify+json", forHTTPHeaderField: "Content-Type")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

200 OK

{
    "_links": {
        "deviceAuthGrant.consent": {
            "href": "https://auth.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/03f82b85-1b9a-4b0c-bc20-fbe76c81caec"
        },
        "self": {
            "href": "https://auth.pingone.com/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/03f82b85-1b9a-4b0c-bc20-fbe76c81caec"
        }
    },
    "id": "03f82b85-1b9a-4b0c-bc20-fbe76c81caec",
    "status": "DAG_CONSENT_REQUIRED",
    "createdAt": "2026-04-20T17:05:19.329Z",
    "expiresAt": "2026-04-20T17:21:13.391Z",
    "_embedded": {
        "user": {
            "id": "0c5b1036-8010-4a89-b28e-64ba5c143e9f"
        }
    },
    "applicationName": "Device-App1776704614",
    "username": "deviceAuth_user_1776704635"
}